
local MAJOR, MINOR = "LibChatAmbiguate", 2 -- Bump minor on changes
local LCA, oldminor = LibStub:NewLibrary(MAJOR, MINOR)
if not LCA then return end -- No upgrade needed

-- I could add upgrading, but the whole point of this is to insert the filters as early as possible.
-- Re-inserting new filters later on would render the library useless as all the other filters would run first.

local events = {
	"CHAT_MSG_CHANNEL",
	"CHAT_MSG_SAY",
	"CHAT_MSG_YELL",
	"CHAT_MSG_WHISPER",
	"CHAT_MSG_WHISPER_INFORM",
	"CHAT_MSG_EMOTE",
	"CHAT_MSG_DND",
	"CHAT_MSG_AFK",
	"CHAT_MSG_GUILD",
	"CHAT_MSG_OFFICER",
	"CHAT_MSG_PARTY_LEADER",
	"CHAT_MSG_PARTY",
	"CHAT_MSG_RAID_LEADER",
	"CHAT_MSG_RAID",
	"CHAT_MSG_INSTANCE_CHAT_LEADER",
	"CHAT_MSG_INSTANCE_CHAT",
}

local Ambiguate = Ambiguate
local filter = function(_, _, msg, player, ...)
	local normalPlayer = Ambiguate(player, "none")
	return false, msg, normalPlayer, ...
end
for i = 1, #events do
	ChatFrame_AddMessageEventFilter(events[i], filter)
end
LCA.filter = filter


--[[
	-- This fixes popup window functionality --
	We create a wrapper around FloatingChatFrameManager_OnEvent
	so that it doesn't create new windows with server names appended to it.
--]]

local FloatingChatFrameManager_OnEvent, FloatingChatFrameManager = FloatingChatFrameManager_OnEvent, FloatingChatFrameManager
LCA.frame = LCA.frame or CreateFrame("Frame")
LCA.eventFunc = LCA.eventFunc or function(_, event, msg, player, ...)
	local normalPlayer = Ambiguate(player, "none")
	FloatingChatFrameManager_OnEvent(FloatingChatFrameManager, event, msg, normalPlayer, ...)
end
LCA.frame:SetScript("OnEvent", LCA.eventFunc)

for i = 1, #ChatTypeGroup["WHISPER"] do
	local event = ChatTypeGroup["WHISPER"][i]
	FloatingChatFrameManager:UnregisterEvent(event)
	LCA.frame:RegisterEvent(event)
end


